<template>
  <li class="notification">
    <h3 class="notification-type">
      <NuxtLink
        class="fr-link"
        :to="itemLink"
        target="_self"
      >
        {{ NOTIFICATION_TYPE_OPTIONS.get(notification.type) }}
      </NuxtLink>
    </h3>
    <span
      :class="[
        'notification-icon',
        NOTIFICATION_TYPE_ICONS.get(notification.type)
      ]"
      aria-hidden="true"
    ></span>
    <span class="notification-date">{{
      formatDate(notification.date_created)
    }}</span>
    <span class="notification-beneficiary">{{
      beneficiaryName(beneficiary)
    }}</span>
    <button
      ref="toggleReadButton"
      class="notification-toggle-read fr-btn fr-btn--sm fr-icon-check-line"
      :class="{ 'fr-btn--tertiary': !isRead }"
      :title="toggleReadButtonLabel"
      @click="onToggleRead"
    >
      {{ toggleReadButtonLabel }}
    </button>
  </li>
</template>

<script setup>
  import { formatDate } from '~~/utils'
  import { ORIGIN_PAGE_PARAMETER } from '~~/utils/constants'
  import { BeneficiaryTab } from '~~/utils/constants/beneficiary-tabs'
  import {
    NotificationType,
    NOTIFICATION_TYPE_ICONS,
    NOTIFICATION_TYPE_OPTIONS
  } from '~~/utils/constants/notifications'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { beneficiaryName } from '~/utils/beneficiary'
  import { Routes } from '~/utils/routing/routes'

  const { $apiRequest, $snackbar } = useNuxtApp()
  const route = useRoute()

  const props = defineProps({
    notification: { type: Object, required: true }
  })

  const emit = defineEmits(['toggleRead'])

  const toggleReadButton = ref(null)

  const item = computed(() => props.notification.item[0].item)
  const beneficiary = computed(() => item.value.beneficiary)

  const isRead = computed(() => props.notification.read)

  const toggleReadButtonLabel = computed(() =>
    isRead.value ? 'Marquer comme non-lu' : 'Marquer comme lu'
  )

  const beneficiaryLink = computed(() =>
    Routes.Beneficiary(beneficiary.value.id)
  )

  const itemTab = computed(() => {
    switch (props.notification.type) {
      case NotificationType.NewDocument:
        return BeneficiaryTab.Documents
      case NotificationType.DueDate:
      case NotificationType.HandlingDate:
      case NotificationType.NewComment:
        return BeneficiaryTab.History
      default:
        return BeneficiaryTab.Details
    }
  })

  const itemLink = computed(() => {
    return {
      path: `${beneficiaryLink.value}`,
      query: {
        tab: itemTab.value,
        item: item.value.id,
        [ORIGIN_PAGE_PARAMETER]: route.path
      }
    }
  })

  async function onToggleRead() {
    try {
      const res = await $apiRequest(
        `/items/notifications/${props.notification.id}`,
        {
          method: 'patch',
          data: { read: !isRead.value }
        }
      )

      if (res.status === 200) emit('toggleRead')
      else throw new Error(errorResponseMessage(res))
    } catch (err) {
      const submittedState = isRead.value ? 'non-lue' : 'lue'
      $snackbar.error(
        `La notification n'a pas pu être marquée comme ${submittedState}.`,
        () => toggleReadButton.value?.focus()
      )
    }
  }
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/src/core/index' as dsfr;
  @use '@gouvfr/dsfr/module/color/mixin/element' as dsfr-color-element;

  .notification {
    @include dsfr-color-element.box-shadow(default grey, (), all-1-out);

    border-radius: 0.25rem;
    display: grid;
    row-gap: 0.25rem;
    column-gap: 2rem;
    grid-template-areas: 'type-icon beneficiary read' 'date type read';
    grid-template-columns: min-content auto min-content;
    padding: 0.5rem;
  }

  .notification-type {
    @include dsfr.text-style(sm);

    grid-area: type;
    margin-bottom: 0;
    color: var(--primary);
  }

  .notification-icon {
    grid-area: type-icon;
    color: var(--primary);
  }

  .notification-date {
    @include dsfr.text-style(sm);

    grid-area: date;
    color: var(--primary);
  }

  .notification-beneficiary {
    grid-area: beneficiary;
    font-weight: 700;
  }

  .notification-toggle-read {
    grid-area: read;
    align-self: center;
  }
</style>
